/*
 * 交易按产品汇总
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class UserTradeMonthSummaryController : BaseController
    {
        public UserTradeMonthSummaryController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 交易按产品汇总列表

        /// <summary>
        /// 根据条件查询交易按产品汇总列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(UserTradeMonthSummary data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            List<KqProducts> Brands = db.KqProducts.OrderBy(m => m.Id).ToList();
            ViewBag.Brands = Brands;

            return View();
        }

        #endregion

        #region 根据条件查询交易按产品汇总列表

        /// <summary>
        /// 交易按产品汇总列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(UserTradeMonthSummary data, string MakerCode, string RealName, string StatTypeSelect, string CreateDateData, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("BrandId", "1"); //品牌

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //交易统计类型
            if (!string.IsNullOrEmpty(StatTypeSelect))
            {
                condition += " and StatType=" + StatTypeSelect;
            }
            if (!string.IsNullOrEmpty(CreateDateData))
            {
                string[] datelist = CreateDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                var start = Convert.ToDateTime(datelist[0]).ToString("yyyyMM");
                var end = Convert.ToDateTime(datelist[1]).ToString("yyyyMM");
                condition += " and TradeMonth>=" + Convert.ToInt32(start) + " and TradeMonth<=" + Convert.ToInt32(end) + " ";
            }
            else
            {
                var start = DateTime.Now.AddMonths(-1).ToString("yyyyMM");
                condition += " and TradeMonth >=" + Convert.ToInt32(start);
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserTradeMonthSummary", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                int StatType = int.Parse(dic["StatType"].ToString());
                if (StatType == 0) dic["StatType"] = "直营商户交易统计";
                if (StatType == 1) dic["StatType"] = "团队交易统计";
            }
            return Json(obj);
        }

        #endregion

        #region 增加交易按产品汇总

        /// <summary>
        /// 增加或修改交易按产品汇总信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加交易按产品汇总

        /// <summary>
        /// 增加或修改交易按产品汇总信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(UserTradeMonthSummary data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("UserTradeMonthSummary", Fields, 0);
            AddSysLog(data.Id.ToString(), "UserTradeMonthSummary", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改交易按产品汇总

        /// <summary>
        /// 增加或修改交易按产品汇总信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            UserTradeMonthSummary editData = db.UserTradeMonthSummary.FirstOrDefault(m => m.Id == Id) ?? new UserTradeMonthSummary();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改交易按产品汇总

        /// <summary>
        /// 增加或修改交易按产品汇总信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(UserTradeMonthSummary data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserTradeMonthSummary", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "UserTradeMonthSummary", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除交易按产品汇总信息

        /// <summary>
        /// 删除交易按产品汇总信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserTradeMonthSummary", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserTradeMonthSummary", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserTradeMonthSummary", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserTradeMonthSummary", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserTradeMonthSummary", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserTradeMonthSummary", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("UserTradeMonthSummary", Sort, Id);

            AddSysLog(Id.ToString(), "UserTradeMonthSummary", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.UserTradeMonthSummary.Add(new UserTradeMonthSummary()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "UserTradeMonthSummary", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(UserTradeMonthSummary data, string MakerCode, string RealName, string StatTypeSelect, string CreateDateData)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("BrandId", "1"); //品牌

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //交易统计类型
            if (!string.IsNullOrEmpty(StatTypeSelect))
            {
                condition += " and StatType=" + StatTypeSelect;
            }
            //交易所在月
            if (!string.IsNullOrEmpty(CreateDateData))
            {
                string[] months = CreateDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                DateTime end = DateTime.Parse(months[0] + "-01 00:00:00").AddMonths(1);
                condition += " and CreateDate>='" + months[0] + "-01 00:00:00' and CreateDate<'" + end.ToString("yyyy-MM-dd HH:mm:ss") + "'";
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserTradeMonthSummary", Fields, "Id desc", "0", 1, 20000, condition, "UserId,TradeMonth,BrandId,StatType,TradeAmt,CreditTradeAmt,DebitNotCapTradeAmt,DebitCapTradeAmt", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                int StatType = int.Parse(dic["StatType"].ToString());
                if (StatType == 0) dic["StatType"] = "直营商户交易统计";
                if (StatType == 1) dic["StatType"] = "团队交易统计";
                dic.Remove("UserId");
            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("MakerCode", "创客编码");
            ReturnFields.Add("RealName", "创客姓名");
            ReturnFields.Add("TradeMonth", "交易所在月份");
            ReturnFields.Add("BrandId", "产品类型");
            ReturnFields.Add("StatType", "交易统计类型");
            ReturnFields.Add("TradeAmt", "商户交易总额");
            ReturnFields.Add("CreditTradeAmt", "商户贷记卡交易总金额");
            ReturnFields.Add("DebitNotCapTradeAmt", "商户非封顶借记卡交易总金额");
            ReturnFields.Add("DebitCapTradeAmt", "商户借记卡封顶交易总额");
            ReturnFields.Add("DebitCapTradeNum", "商户借记卡封顶交易总笔数");
            ReturnFields.Add("CreateDate", "创建时间");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "UserTradeMonthSummary", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
